; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"

        This example is a test piece to demonstrate in a very
        effective manner that a polling loop when written properly
        in very efficient code that has the advantage of simplicity
        and flexibility over other techniques when performing
        trivial tasks such as shelling out to another application.

        The example creates 1000 seperate threads which in turn
        synchronously shell out to 1000 instances of a test piece
        and waits for the exit value from each instance before
        closing the thread.

        To evaluate this test piece, you use "Task Manager" to
        watch the handle count increase so that you know the number
        of threads were created and you use a tool from the Sysinternals
        web site called "Process Explorer" to watch the processor usage
        for 1000 running threads which includes changes in the
        system idle process and the system interrupts.

        On the test machine that this example was developed on,
        the processor usage for 1000 threads running 1000 polling
        loops which in turn poll the exit value from each shelled
        application ran at about 5% of processor usage. That is
        one 200th of one percent for each polling loop and this
        includes the thread overhead.

        You can safely assume that the "shell_ex" procedure in the
        MASM32 library which the contents of the thread procedure
        below is based on is very efficient code that is also very
        reliable code and that the use of a polling loop when
        written correctly is very difficult to improve on.

        ----------------------------------------------------- *

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pThread   :DWORD
    LOCAL TI        :DWORD
    LOCAL args      :DWORD

    mov pThread, OFFSET thread
    mov args, 0

    push esi
    mov esi, 1000

  @@:
    invoke CreateThread,NULL,0,pThread,args,NULL,ADDR TI
    sub esi, 1
    jnz @B

    pop esi

    ret

main endp

; 

thread proc args:DWORD

    LOCAL xc    :DWORD          ; exit code
    LOCAL cth   :DWORD          ; current thread handle
    LOCAL cpr   :DWORD          ; current priority status
    LOCAL st_info:STARTUPINFO
    LOCAL pr_info:PROCESS_INFORMATION

  ; ---------------------
  ; zero fill STARTUPINFO
  ; ---------------------
    mov ecx, 17                 ; 68 bytes SIZEOF STARTUPINFO
    lea edx, st_info
    xor eax, eax
  @@:
    mov [edx], eax
    add edx, 4
    sub ecx, 1
    jnz @B

    mov st_info.cb, 68          ; set the structure size member

    fn CreateProcess,NULL,"sleeper.exe",NULL,NULL, \
                     NULL,NULL,NULL,NULL, \
                     ADDR st_info, \
                     ADDR pr_info

    invoke SetPriorityClass,pr_info.hProcess,IDLE_PRIORITY_CLASS

    mov cth, FUNC(GetCurrentThread)
    mov cpr, FUNC(GetThreadPriority,cth)
    invoke SetThreadPriority,cth,THREAD_PRIORITY_IDLE

  ; -------------------------------------------
  ; loop while created process is still active
  ; -------------------------------------------
  @@:
    invoke GetExitCodeProcess,pr_info.hProcess,ADDR xc
    invoke Sleep, 1
    cmp xc, STILL_ACTIVE
    je @B

    invoke SetThreadPriority,cth,cpr

    invoke CloseHandle, pr_info.hThread
    invoke CloseHandle, pr_info.hProcess

    ret

thread endp

; 

end start
